.386
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
include user32.inc
include ws2_32.inc
include masm32.inc

includelib kernel32.lib
includelib user32.lib
includelib ws2_32.lib
includelib masm32.lib

Ping				PROTO	:DWORD
SendEchoRequest		PROTO	:DWORD,:DWORD
RecvEchoReply		PROTO	:DWORD,:DWORD,:DWORD
WaitForEchoReply	PROTO	:DWORD

CheckSum			PROTO	:DWORD, :DWORD
.const
REQ_DATASIZE	equ	32

ECHOREQUEST	struct
	icmphdr	icmp_hdr	<>
	dwTime	DWORD		?
	cData	db		REQ_DATASIZE dup(?)
ECHOREQUEST ends
ECHOREPLY struct
	iphdr	ip_hdr		<>
	echoReq	ECHOREQUEST	<>
;	cFiller	db	256 dup(?)
ECHOREPLY ends

.data
AppName	db	"Ping v1.0",13,10,0
Usage	db	"Usage:	ping <hostname/ip> ",13,10,13,10
		db	"Programmed in MASM by:",13,10
		db	"Thomas Antony",13,10,0
Ping_Data	db	"Hahahahahahahahahahahahahahahah",0

CRLF	db	13,10,0

Msg_Sending		db	"Pinging %s with %d bytes of data",13,10,0
Msg_TimeOut		db	13,10,"TimeOut",0
Msg_Reply		db	13,10,"Reply from: %s: bytes:%d time:%dms TTL:%d",0

Err_WSAStartup	db	"Error initializing the Winsock dll",13,10,0
Err_SockVersion	db	"Error Winsock version 2.2 not supported",13,10,0
Err_Ping		db	"Error pinging host ",13,10,0
Err_Socket		db	"Error creating socket : %d",13,10,0
Err_Resolve		db	"Error resolving host ",13,10,0
Err_Select		db	"Error calling select() : %d",13,10,0
Err_SendTo		db	"Error sending packets using sendto() : %d",13,10,0
Err_RecvFrom	db	"Error receiving packets using recvfrom() : %d",13,10,0
Err_CloseSock	db	"Error closing socket : %d",13,10,0
 
nId			dw	?
nSeq		dw	?
cTTL		dd	?
.data?
HostBuffer	db	256 dup(?)
OutBuffer	db	256 dup(?)

wsadata		WSADATA		<?>
.code
start:
	invoke StdOut,ADDR AppName
	invoke SetConsoleTitle,ADDR AppName
	invoke GetCL,1,ADDR HostBuffer
	.if eax!=1
		invoke StdOut,ADDR Usage
		jmp @F
	.endif
	invoke WSAStartup,101h,ADDR wsadata
	.if eax!=0
		invoke StdOut,ADDR Err_WSAStartup
		jmp @F
	.elseif (wsadata.wVersion!=101h)
		invoke StdOut,ADDR Err_SockVersion
		jmp @F
	.endif
	invoke Ping,ADDR HostBuffer
	.if eax
		invoke wsprintf,ADDR OutBuffer,ADDR Err_Ping,ADDR HostBuffer 
		invoke StdOut,ADDR OutBuffer
		jmp @F
	.endif
@@:	invoke WSACleanup
	invoke ExitProcess,0
Ping proc uses ebx esi edi host:DWORD
	LOCAL rawSocket:SOCKET
	LOCAL saDest:sockaddr_in
	LOCAL saSrc:sockaddr_in
	LOCAL dwTimeSent:DWORD
	LOCAL dwElapsed:DWORD
	
	invoke socket,AF_INET,SOCK_RAW,IPPROTO_ICMP
	.if eax==SOCKET_ERROR
		invoke WSAGetLastError
		invoke wsprintf,ADDR OutBuffer,ADDR Err_Socket,eax
		invoke StdOut,ADDR OutBuffer 
		ret
	.endif
	mov rawSocket,eax
	invoke inet_addr,host
	.if eax==INADDR_NONE
		invoke gethostbyname,host
		.if eax==0
			invoke StdOut,ADDR Err_Resolve
			ret
		.endif
		mov eax,[eax+12]	; hostent -> h_addr_list
		mov eax,[eax]
		mov eax,[eax]
	.endif
	mov saDest.sin_addr,eax
	mov saDest.sin_family,AF_INET
	mov saDest.sin_port,0
	
	invoke wsprintf,ADDR OutBuffer,ADDR Msg_Sending,host,REQ_DATASIZE
	invoke StdOut,ADDR OutBuffer
	
	xor ebx,ebx
	.WHILE ebx <4
		invoke SendEchoRequest,rawSocket,ADDR saDest
		invoke WaitForEchoReply,rawSocket
		.if eax==SOCKET_ERROR
			invoke WSAGetLastError
			invoke wsprintf,ADDR OutBuffer,ADDR Err_Select,eax
			invoke StdOut,ADDR OutBuffer
			.BREAK
		.endif
		.if !eax
			invoke StdOut,ADDR Msg_TimeOut
			.BREAK
		.endif
		invoke RecvEchoReply,rawSocket,ADDR saSrc,ADDR cTTL
		mov dwTimeSent,eax

		invoke GetTickCount
		sub eax,dwTimeSent
		mov dwElapsed,eax
		
		invoke wsprintf,ADDR OutBuffer,ADDR Msg_Reply,host,REQ_DATASIZE,dwElapsed,cTTL
		invoke StdOut,ADDR OutBuffer
		inc ebx
	.ENDW
	invoke StdOut,ADDR CRLF
	invoke closesocket,rawSocket
	.if eax==SOCKET_ERROR
		push eax
		invoke WSAGetLastError
		invoke wsprintf,ADDR OutBuffer,Err_CloseSock,eax
		invoke StdOut,ADDR OutBuffer
		pop eax
	.endif
	Ret
Ping EndP
SendEchoRequest proc s:SOCKET,ToAddr:DWORD
	LOCAL echoReq:ECHOREQUEST
	
	mov echoReq.icmphdr.icmp_type,ICMP_ECHOREQ
	mov echoReq.icmphdr.icmp_code,0
	mov echoReq.icmphdr.icmp_cksum,0
	inc nId
	mov ax,nId
	mov echoReq.icmphdr.icmp_id,ax
	inc nSeq
	mov ax,nSeq
	mov echoReq.icmphdr.icmp_seq,ax
	
	lea eax,echoReq.cData
	invoke lstrcpy,eax,ADDR Ping_Data
	
	invoke GetTickCount
	mov echoReq.dwTime,eax
	
	lea eax,echoReq.icmphdr
	lea edx,echoReq.dwTime
	invoke CheckSum,ADDR echoReq,SIZEOF echoReq
	mov echoReq.icmphdr.icmp_cksum,ax
	
	invoke sendto,s,ADDR echoReq,SIZEOF ECHOREQUEST,0,ToAddr,SIZEOF sockaddr_in
	.if eax==SOCKET_ERROR
		push eax
		invoke WSAGetLastError
		invoke wsprintf,ADDR OutBuffer,ADDR Err_SendTo,eax
		invoke StdOut,ADDR OutBuffer
		pop eax
	.endif
	Ret
SendEchoRequest EndP
RecvEchoReply proc s:SOCKET,lpFrom:DWORD,pTTL:DWORD
	LOCAL echoReply:ECHOREPLY
	LOCAL addrLen:DWORD
	
	mov addrLen,SIZEOF sockaddr_in
	invoke recvfrom,s,ADDR echoReply,SIZEOF ECHOREPLY,0,lpFrom,ADDR addrLen
	.if eax==SOCKET_ERROR
		push eax
		invoke WSAGetLastError
		invoke wsprintf,ADDR OutBuffer,ADDR Err_RecvFrom,eax
		invoke StdOut,ADDR OutBuffer
		pop eax
	.endif
	
	movzx eax,echoReply.iphdr.ip_ttl
	mov cTTL,eax
	mov eax,echoReply.echoReq.dwTime
	Ret
RecvEchoReply EndP
WaitForEchoReply proc s:SOCKET
	LOCAL TimeOut:timeval
	LOCAL readfds:fd_set
	
	mov readfds.fd_count,1

	mov eax,s
	mov readfds.fd_array,eax
	mov TimeOut.tv_sec,5
	mov TimeOut.tv_usec,0
	invoke select,1,ADDR readfds,0,0,ADDR TimeOut 
	Ret
WaitForEchoReply EndP
;Contributed by Dude of Dudes
CheckSum proc pBuffer:dword, lenBuffer:dword

	;calculates the ones complement sum of all the word values in buffer
	;pointed to by pBuffer. lenBuffer is length in bytes.
	;returns checksum in ax in network byte order (NON-little endian)
	xor eax, eax				;zero checksum
	mov edx, pBuffer			;pointer to words

	.while lenBuffer > 1
		xor ecx, ecx
		mov cx, word ptr [edx]		;get next word value
		xchg cl, ch			;convert network byte order to 
						;little endian
		add eax, ecx			;add current word to checksum
		add edx, 2			;point to next word
		sub lenBuffer, 2		;dec counter
	.endw

	.if lenBuffer				;if lenBuffer was odd number
		xor cl, cl			;add 0 padding
		mov ch, byte ptr [edx]	
		add ax, cx			;add last single byte to checksum
	.endif

	;to get the correct one's complement sum of all the words we need to add
	;the carry(s) to the word value 
	mov ecx, eax			
	shr eax, 16				;MSB is in ax
	add ax, cx				;ax holds sum
	not ax					;ax holds one's complement
						;of sum
	xchg al, ah				;put into Network byte order
	ret
CheckSum endp
end start